--- //depot/vendor/freebsd/src/sys/netipsec/keysock.c	2004/06/23 02:01:09
+++ //depot/user/rwatson/netperf/sys/netipsec/keysock.c	2004/06/23 21:39:47
@@ -306,6 +306,11 @@
 		pfkeystat.in_msgtype[msg->sadb_msg_type]++;
 	}
 
+	/*
+	 * XXXRW: This will almost certainly cause lock order problems;
+	 * we may need a netisr solution similar to that used in rtsock.
+	 */
+	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list)
 	{
 		if (rp->rcb_proto.sp_family != PF_KEY)
@@ -354,18 +359,21 @@
 			continue;
 
 		if ((n = m_copy(m, 0, (int)M_COPYALL)) == NULL) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			pfkeystat.in_nomem++;
 			return ENOBUFS;
 		}
 
 		if ((error = key_sendup0(rp, n, 0)) != 0) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			return error;
 		}
 
 		n = NULL;
 	}
+	mtx_lock(&rawcb_mtx);
 
 	if (so) {
 		error = key_sendup0(sotorawcb(so), m, 0);
--- //depot/vendor/freebsd/src/sys/netipx/ipx_input.c	2003/11/08 22:30:39
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_input.c	2004/03/19 10:34:30
@@ -72,23 +72,39 @@
 SYSCTL_INT(_net_ipx, OID_AUTO, ipxnetbios, CTLFLAG_RW,
 	   &ipxnetbios, 0, "");
 
-union	ipx_net ipx_zeronet;
-union	ipx_host ipx_zerohost;
+const union	ipx_net ipx_zeronet;
+const union	ipx_host ipx_zerohost;
 
-union	ipx_net	ipx_broadnet;
-union	ipx_host ipx_broadhost;
+const union	ipx_net	ipx_broadnet = { .s_net[0] = 0xffff,
+					    .s_net[1] = 0xffff };
+const union	ipx_host ipx_broadhost = { .s_host[0] = 0xffff,
+					    .s_host[1] = 0xffff,
+					    .s_host[2] = 0xffff };
 
+/*
+ * XXXRW: Locking needed here.
+ */
 struct	ipxstat ipxstat;
+
+/*
+ * XXXRW: These should/could also be const, since they're set only at
+ * init time.
+ */
 struct	sockaddr_ipx ipx_netmask, ipx_hostmask;
 
-static	u_short allones[] = {-1, -1, -1};
+/*
+ * XXXRW: Locking needed here.
+ */
+u_short			ipxpcb_lport_cache;
+struct ipxpcbhead	ipxpcb_list;
+struct ipxpcbhead	ipxrawpcb_list;
 
-struct	ipxpcb ipxpcb;
-struct	ipxpcb ipxrawpcb;
-
 static int ipxqmaxlen = IFQ_MAXLEN;
 static	struct ifqueue ipxintrq;
 
+/*
+ * XXXRW: Locking needed here.
+ */
 long	ipx_pexseq;
 
 static	int ipx_do_route(struct ipx_addr *src, struct route *ro);
@@ -103,13 +119,14 @@
 void
 ipx_init()
 {
-	ipx_broadnet = *(union ipx_net *)allones;
-	ipx_broadhost = *(union ipx_host *)allones;
 
 	read_random(&ipx_pexseq, sizeof ipx_pexseq);
-	ipxpcb.ipxp_next = ipxpcb.ipxp_prev = &ipxpcb;
-	ipxrawpcb.ipxp_next = ipxrawpcb.ipxp_prev = &ipxrawpcb;
-
+	LIST_INIT(&ipxpcb_list);
+	LIST_INIT(&ipxrawpcb_list);
+	
+	/*
+	 * XXXRW: These should be const?
+	 */
 	ipx_netmask.sipx_len = 6;
 	ipx_netmask.sipx_addr.x_net = ipx_broadnet;
 
@@ -133,6 +150,9 @@
 	struct ipx_ifaddr *ia;
 	int len;
 
+	/*
+	 * XXXRW: Would be nice to remove this.
+	 */
 	GIANT_REQUIRED;
 
 	/*
@@ -153,8 +173,7 @@
 	/*
 	 * Give any raw listeners a crack at the packet
 	 */
-	for (ipxp = ipxrawpcb.ipxp_next; ipxp != &ipxrawpcb;
-	     ipxp = ipxp->ipxp_next) {
+	LIST_FOREACH(ipxp, &ipxrawpcb_list, ipxp_list) {
 		struct mbuf *m1 = m_copy(m, 0, (int)M_COPYALL);
 		if (m1 != NULL)
 			ipx_input(m1, ipxp);
@@ -467,8 +486,7 @@
 	/*
 	 * Give any raw listeners a crack at the packet
 	 */
-	for (ipxp = ipxrawpcb.ipxp_next; ipxp != &ipxrawpcb;
-	     ipxp = ipxp->ipxp_next) {
+	LIST_FOREACH(ipxp, &ipxrawpcb_list, ipxp_list) {
 		struct mbuf *m0 = m_copy(m, 0, (int)M_COPYALL);
 		if (m0 != NULL) {
 			register struct ipx *ipx;
--- //depot/vendor/freebsd/src/sys/netipx/ipx_pcb.c	2004/10/18 22:20:34
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_pcb.c	2004/10/19 18:01:38
@@ -56,7 +56,7 @@
 int
 ipx_pcballoc(so, head, td)
 	struct socket *so;
-	struct ipxpcb *head;
+	struct ipxpcbhead *head;
 	struct thread *td;
 {
 	register struct ipxpcb *ipxp;
@@ -107,13 +107,16 @@
 	}
 	ipxp->ipxp_laddr = sipx->sipx_addr;
 noname:
+	/*
+	 * XXXRW: I wonder what causes this loop to terminate...
+	 */
 	if (lport == 0)
 		do {
-			ipxpcb.ipxp_lport++;
-			if ((ipxpcb.ipxp_lport < IPXPORT_RESERVED) ||
-			    (ipxpcb.ipxp_lport >= IPXPORT_WELLKNOWN))
-				ipxpcb.ipxp_lport = IPXPORT_RESERVED;
-			lport = htons(ipxpcb.ipxp_lport);
+			ipxpcb_lport_cache++;
+			if ((ipxpcb_lport_cache < IPXPORT_RESERVED) ||
+			    (ipxpcb_lport_cache >= IPXPORT_WELLKNOWN))
+				ipxpcb_lport_cache = IPXPORT_RESERVED;
+			lport = htons(ipxpcb_lport_cache);
 		} while (ipx_pcblookup(&zeroipx_addr, lport, 0));
 	ipxp->ipxp_lport = lport;
 	return (0);
@@ -325,18 +328,27 @@
 	register struct ipxpcb *ipxp, *oinp;
 	int s = splimp();
 
-	for (ipxp = (&ipxpcb)->ipxp_next; ipxp != (&ipxpcb);) {
+	for (ipxp = LIST_FIRST(&ipxpcb_list); ipxp != NULL;) {
 		if (!ipx_hosteq(*dst,ipxp->ipxp_faddr)) {
-	next:
-			ipxp = ipxp->ipxp_next;
+next:
+			ipxp = LIST_NEXT(ipxp, ipxp_list);
+		}
+		if (ipxp->ipxp_socket == 0) {
+			goto next;
 			continue;
 		}
-		if (ipxp->ipxp_socket == 0)
-			goto next;
 		if (errno) 
 			ipxp->ipxp_socket->so_error = errno;
+		/*
+		 * XXXRW: I can't find any consumers of this interface, and
+		 * so don't know if calling the notify function could result
+		 * in the ipxp list pointers changing.  Before moving this to
+		 * the queue(9) macros, there was some fancy footwork here
+		 * that didn't seem to be useful.  If the list can be changed
+		 * by a notification, it will make locking very difficult.
+		 */
 		oinp = ipxp;
-		ipxp = ipxp->ipxp_next;
+		ipxp = LIST_NEXT(ipxp, ipxp_list);
 		oinp->ipxp_notify_param = param;
 		(*notify)(oinp);
 	}
@@ -374,7 +386,7 @@
 	u_short fport;
 
 	fport = faddr->x_port;
-	for (ipxp = (&ipxpcb)->ipxp_next; ipxp != (&ipxpcb); ipxp = ipxp->ipxp_next) {
+	LIST_FOREACH(ipxp, &ipxpcb_list, ipxp_list) {
 		if (ipxp->ipxp_lport != lport)
 			continue;
 		wildcard = 0;
--- //depot/vendor/freebsd/src/sys/netipx/ipx_pcb.h	2003/01/01 18:50:52
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_pcb.h	2004/03/19 10:34:30
@@ -43,9 +43,7 @@
  * IPX protocol interface control block.
  */
 struct ipxpcb {
-	struct	ipxpcb *ipxp_next;	/* doubly linked list */
-	struct	ipxpcb *ipxp_prev;
-	struct	ipxpcb *ipxp_head;
+	LIST_ENTRY(ipxpcb)	ipxp_list;	/* list of ipxpcbs */
 	struct	socket *ipxp_socket;	/* back pointer to socket */
 	struct	ipx_addr ipxp_faddr;	/* destination address */
 	struct	ipx_addr ipxp_laddr;	/* socket's address */
@@ -58,6 +56,11 @@
 	u_char	ipxp_rpt;		/* last received packet type by ipx_input() */
 };
 
+LIST_HEAD(ipxpcbhead, ipxpcb);
+extern struct ipxpcbhead ipxpcb_list;
+extern struct ipxpcbhead ipxrawpcb_list;
+extern u_short ipxpcb_lport_cache;
+
 /* possible flags */
 
 #define IPXP_IN_ABORT		0x1	/* calling abort through socket */
@@ -82,7 +85,7 @@
 #ifdef _KERNEL
 extern struct ipxpcb ipxpcb;			/* head of list */
 
-int	ipx_pcballoc(struct socket *so, struct ipxpcb *head,
+int	ipx_pcballoc(struct socket *so, struct ipxpcbhead *head,
 			  struct thread *p);
 int	ipx_pcbbind(struct ipxpcb *ipxp, struct sockaddr *nam,
 			 struct thread *p);
--- //depot/vendor/freebsd/src/sys/netipx/ipx_usrreq.c	2004/10/18 22:20:34
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_usrreq.c	2004/10/19 18:01:38
@@ -443,7 +443,7 @@
 	if (ipxp != NULL)
 		return (EINVAL);
 	s = splnet();
-	error = ipx_pcballoc(so, &ipxpcb, td);
+	error = ipx_pcballoc(so, &ipxpcb_list, td);
 	splx(s);
 	if (error == 0)
 		error = soreserve(so, ipxsendspace, ipxrecvspace);
@@ -604,7 +604,7 @@
 	if (td != NULL && (error = suser(td)) != 0)
 		return (error);
 	s = splnet();
-	error = ipx_pcballoc(so, &ipxrawpcb, td);
+	error = ipx_pcballoc(so, &ipxrawpcb_list, td);
 	splx(s);
 	if (error)
 		return (error);
--- //depot/vendor/freebsd/src/sys/netipx/ipx_var.h	2003/03/04 23:20:46
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_var.h	2004/03/19 10:34:30
@@ -66,19 +66,19 @@
 extern int ipxcksum;
 extern long ipx_pexseq;
 extern struct ipxstat ipxstat;
-extern struct ipxpcb ipxrawpcb;
 extern struct pr_usrreqs ipx_usrreqs;
 extern struct pr_usrreqs ripx_usrreqs;
 extern struct sockaddr_ipx ipx_netmask;
 extern struct sockaddr_ipx ipx_hostmask;
 
-extern union ipx_net ipx_zeronet;
-extern union ipx_host ipx_zerohost;
-extern union ipx_net ipx_broadnet;
-extern union ipx_host ipx_broadhost;
+extern const union ipx_net ipx_zeronet;
+extern const union ipx_host ipx_zerohost;
+extern const union ipx_net ipx_broadnet;
+extern const union ipx_host ipx_broadhost;
 
 struct ifnet;
 struct ipx_addr;
+struct ipxpcb;
 struct mbuf;
 struct thread;
 struct route;
--- //depot/vendor/freebsd/src/sys/netipx/spx_usrreq.c	2004/07/12 19:36:23
+++ //depot/user/rwatson/netperf/sys/netipx/spx_usrreq.c	2004/07/12 19:43:55
@@ -1340,7 +1340,7 @@
 	if (ipxp != NULL)
 		return (EISCONN);
 	s = splnet();
-	error = ipx_pcballoc(so, &ipxpcb, td);
+	error = ipx_pcballoc(so, &ipxpcb_list, td);
 	if (error)
 		goto spx_attach_end;
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
@@ -1551,6 +1551,7 @@
 	ipxp = sotoipxpcb(so);
 	cb = ipxtospxpcb(ipxp);
 
+	/* XXXRW: sb_state locking? */
 	if ((cb->s_oobflags & SF_IOOB) || so->so_oobmark ||
 	    (so->so_rcv.sb_state & SBS_RCVATMARK)) {
 		m->m_len = 1;
@@ -1761,9 +1762,7 @@
 	register struct spxpcb *cb;
 	int s = splnet();
 
-	ipxp = ipxpcb.ipxp_next;
-	if (ipxp != NULL)
-	for (; ipxp != &ipxpcb; ipxp = ipxp->ipxp_next)
+	LIST_FOREACH(ipxp, &ipxpcb_list, ipxp_list) {
 		if ((cb = (struct spxpcb *)ipxp->ipxp_pcb) != NULL &&
 		    (cb->s_flags & SF_DELACK)) {
 			cb->s_flags &= ~SF_DELACK;
@@ -1771,6 +1770,7 @@
 			spxstat.spxs_delack++;
 			spx_output(cb, (struct mbuf *)NULL);
 		}
+	}
 	splx(s);
 }
 
@@ -1789,15 +1789,15 @@
 
 	/*
 	 * Search through tcb's and update active timers.
+	 *
+	 * XXXRW: spx_timers() may remove an ipxpcb entry, so we have to be
+	 * ready to continue despite that.  The logic here is a bit
+	 * obfuscated.
 	 */
-	ip = ipxpcb.ipxp_next;
-	if (ip == NULL) {
-		splx(s);
-		return;
-	}
-	while (ip != &ipxpcb) {
+	ip = LIST_FIRST(&ipxpcb_list);
+	while (ip != NULL) {
+		ipnxt = LIST_NEXT(ip, ipxp_list);
 		cb = ipxtospxpcb(ip);
-		ipnxt = ip->ipxp_next;
 		if (cb == NULL)
 			goto tpgone;
 		for (i = 0; i < SPXT_NTIMERS; i++) {
@@ -1811,7 +1811,7 @@
 		if (cb->s_rtt)
 			cb->s_rtt++;
 tpgone:
-		ip = ipnxt;
+		ip = LIST_NEXT(ip, ipxp_list);
 	}
 	spx_iss += SPX_ISSINCR/PR_SLOWHZ;		/* increment iss */
 	splx(s);
--- //depot/vendor/freebsd/src/sys/netkey/keysock.c	2004/08/27 18:45:30
+++ //depot/user/rwatson/netperf/sys/netkey/keysock.c	2004/08/28 14:27:28
@@ -214,6 +214,11 @@
 		pfkeystat.in_msgtype[msg->sadb_msg_type]++;
 	}
 
+	/*
+	 * XXXRW: This will almost certainly cause lock order problems;
+	 * we may need a netisr solution similar to that used in rtsock.
+	 */
+	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list) {
 		if (rp->rcb_proto.sp_family != PF_KEY)
 			continue;
@@ -261,6 +266,7 @@
 			continue;
 
 		if ((n = m_copy(m, 0, (int)M_COPYALL)) == NULL) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			pfkeystat.in_nomem++;
 			return ENOBUFS;
@@ -275,6 +281,7 @@
 
 		n = NULL;
 	}
+	mtx_unlock(&rawcb_mtx);
 
 	if (so) {
 		error = key_sendup0(sotorawcb(so), m, 0);
--- //depot/vendor/freebsd/src/sys/netsmb/smb_trantcp.c	2004/06/17 22:51:43
+++ //depot/user/rwatson/netperf/sys/netsmb/smb_trantcp.c	2004/06/18 00:24:39
@@ -184,6 +184,9 @@
 	return 0;
 }
 
+/*
+ * XXXRW: nb_upcall() is called without Giant, which is probably safeish.
+ */
 static void
 nb_upcall(struct socket *so, void *arg, int waitflag)
 {
--- //depot/vendor/freebsd/src/sys/nfsclient/bootp_subr.c	2004/07/28 21:55:45
+++ //depot/user/rwatson/netperf/sys/nfsclient/bootp_subr.c	2004/08/02 01:36:03
@@ -983,7 +983,7 @@
 	struct ifaddr *ifa;
 	struct sockaddr_dl *sdl;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	error = socreate(AF_INET, &ifctx->so, SOCK_DGRAM, 0, td->td_ucred, td);
 	if (error != 0)
--- //depot/vendor/freebsd/src/sys/nfsclient/nfs_socket.c	2004/08/25 01:25:22
+++ //depot/user/rwatson/netperf/sys/nfsclient/nfs_socket.c	2004/08/25 20:28:45
@@ -1197,6 +1197,7 @@
 		 * Set r_rtt to -1 in case we fail to send it now.
 		 */
 		rep->r_rtt = -1;
+		/* XXXRW: Unlocked reads. */
 		if (sbspace(&so->so_snd) >= rep->r_mreq->m_pkthdr.len &&
 		   ((nmp->nm_flag & NFSMNT_DUMBTIMR) ||
 		    (rep->r_flags & R_SENT) ||
--- //depot/vendor/freebsd/src/sys/nfsclient/nfs_vfsops.c	2004/10/22 09:01:20
+++ //depot/user/rwatson/netperf/sys/nfsclient/nfs_vfsops.c	2004/11/03 14:10:39
@@ -393,7 +393,7 @@
 	u_long l;
 	char buf[128];
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 #if defined(BOOTP_NFSROOT) && defined(BOOTP)
 	bootpc_init();		/* use bootp to get nfs_diskless filled in */
--- //depot/vendor/freebsd/src/sys/nfsserver/nfs_syscalls.c	2004/06/17 22:51:43
+++ //depot/user/rwatson/netperf/sys/nfsserver/nfs_syscalls.c	2004/06/18 00:24:39
@@ -607,6 +607,10 @@
 		NFSD_UNLOCK();
 		slp->ns_fp = NULL;
 		so = slp->ns_so;
+		/*
+		 * XXXRW: More general locking issues here relating to
+		 * upcalls.
+		 */
 		SOCKBUF_LOCK(&so->so_rcv);
 		so->so_rcv.sb_flags &= ~SB_UPCALL;
 		SOCKBUF_UNLOCK(&so->so_rcv);
--- //depot/vendor/freebsd/src/sys/pci/if_dc.c	2004/10/01 15:25:23
+++ //depot/user/rwatson/netperf/sys/pci/if_dc.c	2004/10/19 20:17:38
@@ -349,8 +349,6 @@
 #define SIO_SET(x)	DC_SETBIT(sc, DC_SIO, (x))
 #define SIO_CLR(x)	DC_CLRBIT(sc, DC_SIO, (x))
 
-#define IS_MPSAFE 	0
-
 static void
 dc_delay(struct dc_softc *sc)
 {
@@ -2192,8 +2190,6 @@
 	/* XXX: bleah, MTU gets overwritten in ether_ifattach() */
 	ifp->if_mtu = ETHERMTU;
 	ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX | IFF_MULTICAST;
-	if (!IS_MPSAFE)
-		ifp->if_flags |= IFF_NEEDSGIANT;
 	ifp->if_ioctl = dc_ioctl;
 	ifp->if_start = dc_start;
 	ifp->if_watchdog = dc_watchdog;
@@ -2273,7 +2269,7 @@
 #endif
 	ifp->if_capenable = ifp->if_capabilities;
 
-	callout_init(&sc->dc_stat_ch, IS_MPSAFE ? CALLOUT_MPSAFE : 0);
+	callout_init(&sc->dc_stat_ch, debug_mpsafenet ? CALLOUT_MPSAFE : 0);
 
 #ifdef SRM_MEDIA
 	sc->dc_srm_media = 0;
@@ -2307,8 +2303,7 @@
 	ether_ifattach(ifp, eaddr);
 
 	/* Hook interrupt last to avoid having to lock softc */
-	error = bus_setup_intr(dev, sc->dc_irq, INTR_TYPE_NET |
-	    (IS_MPSAFE ? INTR_MPSAFE : 0),
+	error = bus_setup_intr(dev, sc->dc_irq, INTR_TYPE_NET | INTR_MPSAFE,
 	    dc_intr, sc, &sc->dc_intrhand);
 
 	if (error) {
--- //depot/vendor/freebsd/src/sys/pci/if_pcn.c	2004/09/06 13:45:26
+++ //depot/user/rwatson/netperf/sys/pci/if_pcn.c	2004/09/09 01:21:53
@@ -577,7 +577,7 @@
 	ether_ifattach(ifp, (u_int8_t *) eaddr);
 
 	/* Hook interrupt last to avoid having to lock softc */
-	error = bus_setup_intr(dev, sc->pcn_irq, INTR_TYPE_NET,
+	error = bus_setup_intr(dev, sc->pcn_irq, INTR_TYPE_NET | INTR_MPSAFE,
 	    pcn_intr, sc, &sc->pcn_intrhand);
 
 	if (error) {
--- //depot/vendor/freebsd/src/sys/rpc/rpcclnt.c	2004/07/15 22:25:35
+++ //depot/user/rwatson/netperf/sys/rpc/rpcclnt.c	2004/07/19 22:28:50
@@ -145,7 +145,7 @@
 
 /* XXX ugly debug strings */
 #define RPC_ERRSTR_ACCEPTED_SIZE 6
-char *rpc_errstr_accepted[RPC_ERRSTR_ACCEPTED_SIZE] = {
+const char *rpc_errstr_accepted[RPC_ERRSTR_ACCEPTED_SIZE] = {
 	"",			/* no good message... */
 	"remote server hasn't exported program.",
 	"remote server can't support version number.",
@@ -154,13 +154,13 @@
 	"remote error.  remote side memory allocation failure?"
 };
 
-char *rpc_errstr_denied[2] = {
+const char *rpc_errstr_denied[2] = {
 	"remote server doesnt support rpc version 2!",
 	"remote server authentication error."
 };
 
 #define RPC_ERRSTR_AUTH_SIZE 6
-char *rpc_errstr_auth[RPC_ERRSTR_AUTH_SIZE] = {
+const char *rpc_errstr_auth[RPC_ERRSTR_AUTH_SIZE] = {
 	"",
 	"auth error: bad credential (seal broken).",
 	"auth error: client must begin new session.",
@@ -360,7 +360,7 @@
 		RPC_RETURN(EFAULT);
 	}
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/* create the socket */
 	rpc->rc_so = NULL;
@@ -618,7 +618,7 @@
 {
 	struct socket  *so;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rpc->rc_so) {
 		so = rpc->rc_so;
@@ -669,7 +669,7 @@
 #endif
 	int error, soflags, flags;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rep) {
 		if (rep->r_flags & R_SOFTTERM) {
@@ -754,7 +754,7 @@
 #endif
 	int error, sotype, rcvflg;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/*
 	 * Set up arguments for soreceive()
@@ -1439,6 +1439,7 @@
 		 * Set r_rtt to -1 in case we fail to send it now.
 		 */
 		rep->r_rtt = -1;
+		SOCKBUF_LOCK(&so->so_snd);
 		if (sbspace(&so->so_snd) >= rep->r_mreq->m_pkthdr.len &&
 		    ((rpc->rc_flag & RPCCLNT_DUMBTIMR) ||
 		     (rep->r_flags & R_SENT) ||
@@ -1473,6 +1474,7 @@
 				rep->r_rtt = 0;
 			}
 		}
+		SOCKBUF_UNLOCK(&so->so_snd);
 	}
 	splx(s);
 
--- //depot/vendor/freebsd/src/sys/security/mac/mac_net.c	2004/06/24 03:35:33
+++ //depot/user/rwatson/netperf/sys/security/mac/mac_net.c	2004/06/24 03:49:05
@@ -260,6 +260,11 @@
 	MAC_PERFORM(copy_ifnet_label, src, dest);
 }
 
+/*
+ * XXXRW: Need to use a routine to copy the ifnet label while holding the
+ * ifnet mutex, similar to sockets, pipes, vnodes, et al, to avoid holding
+ * the mutex over the copyin/copyout.
+ */
 static int
 mac_externalize_ifnet_label(struct label *label, char *elements,
     char *outbuf, size_t outbuflen)
@@ -271,6 +276,9 @@
 	return (error);
 }
 
+/*
+ * XXXRW: See comment for mac_externalize_ifnet_label().
+ */
 static int
 mac_internalize_ifnet_label(struct label *label, char *string)
 {
--- //depot/vendor/freebsd/src/sys/sys/socketvar.h	2004/10/18 22:20:34
+++ //depot/user/rwatson/netperf/sys/sys/socketvar.h	2004/10/19 18:01:38
@@ -356,6 +356,7 @@
 		SOCK_UNLOCK(so);					\
 		ACCEPT_UNLOCK();					\
 	}								\
+	so = NULL;							\
 } while (0)
 
 #define	sotryfree(so) do {						\
@@ -367,6 +368,7 @@
 		SOCK_UNLOCK(so);					\
 		ACCEPT_UNLOCK();					\
 	}								\
+	so = NULL;							\
 } while(0)
 
 /*
